// DO NOT EDIT
// Generated by JFlex 1.9.1 http://jflex.de/
// source: jflex/S202_NearAuthorities.jflex

/*******************************************************************************
 * Copyright (c) 2022-2029 Institute of Legal Information and Judicial Systems (IGSG-CNR)
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and 
 * limitations under the License.
 *  
 * Authors: Lorenzo Bacci (IGSG-CNR)
 ******************************************************************************/
package it.cnr.igsg.linkoln;

import java.util.ArrayList;


@SuppressWarnings("fallthrough")
class S202_NearAuthorities extends LinkolnAnnotationService {

  /** This character denotes the end of file. */
  public static final int YYEOF = -1;

  /** Initial size of the lookahead buffer. */
  private static final int ZZ_BUFFERSIZE = 16384;

  // Lexical states.
  public static final int YYINITIAL = 0;
  public static final int lkn = 2;

  /**
   * ZZ_LEXSTATE[l] is the state in the DFA for the lexical state l
   * ZZ_LEXSTATE[l+1] is the state in the DFA for the lexical state l
   *                  at the beginning of a line
   * l is of the form l = 2*k, k a non negative integer
   */
  private static final int ZZ_LEXSTATE[] = {
     0,  0,  1, 1
  };

  /**
   * Top-level table for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_TOP = zzUnpackcmap_top();

  private static final String ZZ_CMAP_TOP_PACKED_0 =
    "\1\0\1\u0100\37\u0200\1\u0300\u10de\u0200";

  private static int [] zzUnpackcmap_top() {
    int [] result = new int[4352];
    int offset = 0;
    offset = zzUnpackcmap_top(ZZ_CMAP_TOP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_top(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Second-level tables for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_BLOCKS = zzUnpackcmap_blocks();

  private static final String ZZ_CMAP_BLOCKS_PACKED_0 =
    "\12\0\1\1\2\0\1\1\24\0\1\1\13\0\1\2"+
    "\1\3\12\4\1\5\6\0\1\6\1\7\1\10\1\11"+
    "\1\12\1\13\1\14\1\15\1\16\1\17\1\20\1\21"+
    "\1\22\1\23\1\24\1\25\1\17\1\26\1\27\1\30"+
    "\1\31\3\17\1\32\1\17\1\33\1\0\1\34\1\0"+
    "\1\35\1\0\1\36\1\37\1\40\1\41\1\42\1\43"+
    "\1\44\1\45\1\46\1\47\1\50\1\51\1\52\1\53"+
    "\1\54\1\55\1\47\1\56\1\57\1\60\1\61\3\47"+
    "\1\62\1\47\265\0\2\63\115\0\1\64\u01aa\0\1\65"+
    "\325\0";

  private static int [] zzUnpackcmap_blocks() {
    int [] result = new int[1024];
    int offset = 0;
    offset = zzUnpackcmap_blocks(ZZ_CMAP_BLOCKS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_blocks(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /**
   * Translates DFA states to action switch labels.
   */
  private static final int [] ZZ_ACTION = zzUnpackAction();

  private static final String ZZ_ACTION_PACKED_0 =
    "\2\0\1\1\1\2\6\1\1\3\4\0\1\3\3\0"+
    "\1\3\3\0\1\4\100\0\1\5\46\0\1\5\14\0"+
    "\1\5\16\0\1\5\2\0\1\5\15\0\1\6\3\0"+
    "\1\7";

  private static int [] zzUnpackAction() {
    int [] result = new int[177];
    int offset = 0;
    offset = zzUnpackAction(ZZ_ACTION_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAction(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Translates a state to a row index in the transition table
   */
  private static final int [] ZZ_ROWMAP = zzUnpackRowMap();

  private static final String ZZ_ROWMAP_PACKED_0 =
    "\0\0\0\66\0\154\0\154\0\242\0\330\0\u010e\0\u0144"+
    "\0\u017a\0\u01b0\0\u01e6\0\u021c\0\u0252\0\u01e6\0\u0288\0\242"+
    "\0\u02be\0\u02f4\0\u032a\0\154\0\u0360\0\u0396\0\u03cc\0\154"+
    "\0\u0402\0\u0438\0\u046e\0\u04a4\0\u04da\0\u0510\0\u0546\0\u057c"+
    "\0\u05b2\0\u05e8\0\u061e\0\u0654\0\u068a\0\u06c0\0\u06f6\0\u072c"+
    "\0\u0762\0\u0798\0\u07ce\0\u0804\0\u083a\0\u0870\0\u08a6\0\u08dc"+
    "\0\u0912\0\u0948\0\u097e\0\u09b4\0\u09ea\0\u0a20\0\u0a56\0\u0a8c"+
    "\0\u0ac2\0\u0af8\0\u0b2e\0\u0b64\0\u0b9a\0\u0bd0\0\u0c06\0\u0c3c"+
    "\0\u0c72\0\u0ca8\0\u0cde\0\u0d14\0\u0d4a\0\u0d80\0\u0db6\0\u0dec"+
    "\0\u0e22\0\u0e58\0\u0e8e\0\u0ec4\0\u0efa\0\u0f30\0\u0f66\0\u0f9c"+
    "\0\u0fd2\0\u1008\0\u103e\0\u1074\0\u10aa\0\u10e0\0\u1116\0\u114c"+
    "\0\154\0\u1182\0\u11b8\0\u11ee\0\u1224\0\u125a\0\u1290\0\u12c6"+
    "\0\u12fc\0\u1332\0\u1368\0\u139e\0\u13d4\0\u140a\0\u1440\0\u1476"+
    "\0\u14ac\0\u14e2\0\u1518\0\u154e\0\u1584\0\u15ba\0\u15f0\0\u1626"+
    "\0\u165c\0\u1692\0\u16c8\0\u16fe\0\u1734\0\u176a\0\u17a0\0\u17d6"+
    "\0\u180c\0\u1842\0\u1878\0\u18ae\0\u18e4\0\u191a\0\u1950\0\u1986"+
    "\0\u19bc\0\u19f2\0\u1986\0\u1a28\0\u1a5e\0\u1a94\0\u1aca\0\u1b00"+
    "\0\u1b36\0\u1b6c\0\u1ba2\0\u1bd8\0\u1c0e\0\u1c0e\0\u1c44\0\u1c7a"+
    "\0\u1cb0\0\u1ce6\0\u1d1c\0\u1d52\0\u1d88\0\u1dbe\0\u1df4\0\u1e2a"+
    "\0\u1e60\0\u1e96\0\u1ecc\0\u1f02\0\u1f02\0\u1f38\0\u1f6e\0\u1f6e"+
    "\0\u1fa4\0\u1fda\0\u2010\0\u2046\0\u207c\0\u20b2\0\u20e8\0\u211e"+
    "\0\u2154\0\u218a\0\u21c0\0\u21f6\0\154\0\u222c\0\u2262\0\u2298"+
    "\0\154";

  private static int [] zzUnpackRowMap() {
    int [] result = new int[177];
    int offset = 0;
    offset = zzUnpackRowMap(ZZ_ROWMAP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackRowMap(String packed, int offset, int [] result) {
    int i = 0;  /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length() - 1;
    while (i < l) {
      int high = packed.charAt(i++) << 16;
      result[j++] = high | packed.charAt(i++);
    }
    return j;
  }

  /**
   * The transition table of the DFA
   */
  private static final int [] ZZ_TRANS = zzUnpacktrans();

  private static final String ZZ_TRANS_PACKED_0 =
    "\2\3\1\4\3\3\2\5\1\6\22\5\1\7\2\3"+
    "\2\10\1\11\22\10\36\3\1\12\32\3\70\0\1\13"+
    "\65\0\1\13\10\0\1\14\27\0\1\14\43\0\1\15"+
    "\27\0\1\15\16\0\1\16\65\0\1\16\10\0\1\14"+
    "\27\0\1\14\25\0\1\17\70\0\25\20\3\0\25\20"+
    "\31\0\1\21\27\0\1\21\27\0\1\22\27\0\1\22"+
    "\14\0\1\22\21\0\1\23\27\0\1\23\16\0\1\24"+
    "\106\0\1\25\27\0\1\25\32\0\1\26\27\0\1\26"+
    "\14\0\1\26\5\0\1\27\103\0\1\30\27\0\1\30"+
    "\20\0\1\31\1\32\1\33\1\34\1\35\6\31\1\36"+
    "\1\37\3\31\1\40\4\31\2\0\1\31\1\0\1\41"+
    "\1\42\1\43\1\44\6\0\1\45\1\46\3\0\1\47"+
    "\14\0\1\50\25\31\2\0\1\31\35\0\1\50\20\31"+
    "\1\51\4\31\2\0\1\31\20\0\1\52\14\0\1\50"+
    "\13\31\1\53\11\31\2\0\1\31\13\0\1\54\21\0"+
    "\1\50\16\31\1\55\6\31\2\0\1\31\16\0\1\56"+
    "\16\0\1\50\23\31\1\57\1\31\2\0\1\31\23\0"+
    "\1\60\11\0\1\50\4\31\1\61\20\31\2\0\1\31"+
    "\4\0\1\62\30\0\1\50\10\31\1\63\14\31\2\0"+
    "\1\31\10\0\1\64\14\0\1\64\7\0\1\50\4\31"+
    "\1\65\20\31\2\0\1\31\4\0\1\66\51\0\1\52"+
    "\27\0\1\52\30\0\1\54\27\0\1\54\40\0\1\56"+
    "\27\0\1\56\42\0\1\60\27\0\1\60\16\0\1\62"+
    "\27\0\1\62\41\0\1\64\27\0\1\64\14\0\1\64"+
    "\14\0\1\66\27\0\1\66\23\0\1\50\1\0\3\50"+
    "\1\67\25\50\2\0\31\50\5\0\1\50\4\31\1\70"+
    "\20\31\2\0\1\31\4\0\1\71\35\0\1\71\27\0"+
    "\1\71\30\0\1\50\25\31\2\0\1\72\65\0\1\73"+
    "\35\0\1\50\2\31\1\74\22\31\2\0\1\31\2\0"+
    "\1\75\35\0\1\75\27\0\1\75\32\0\1\50\25\31"+
    "\2\0\1\76\65\0\1\77\35\0\1\50\6\31\1\100"+
    "\16\31\2\0\1\31\6\0\1\101\35\0\1\101\27\0"+
    "\1\101\26\0\1\50\15\31\1\102\7\31\2\0\1\31"+
    "\15\0\1\103\35\0\1\103\27\0\1\103\17\0\1\50"+
    "\5\31\1\104\1\105\16\31\2\0\1\31\5\0\1\106"+
    "\1\107\34\0\1\106\1\107\26\0\1\106\1\107\25\0"+
    "\1\110\66\0\1\50\1\111\24\31\2\0\1\31\1\112"+
    "\35\0\1\112\27\0\1\112\34\0\1\50\1\113\17\31"+
    "\1\114\4\31\2\0\1\31\1\115\17\0\1\116\15\0"+
    "\1\115\17\0\1\116\7\0\1\115\17\0\1\116\14\0"+
    "\1\50\22\31\1\117\2\31\2\0\1\31\22\0\1\120"+
    "\35\0\1\120\27\0\1\120\12\0\1\50\2\31\1\33"+
    "\10\31\1\36\11\31\2\0\1\31\2\0\1\42\10\0"+
    "\1\45\24\0\1\42\10\0\1\45\16\0\1\42\10\0"+
    "\1\45\21\0\1\50\25\31\2\0\1\121\65\0\1\122"+
    "\35\0\1\50\10\31\1\123\14\31\2\0\1\31\10\0"+
    "\1\124\14\0\1\124\20\0\1\124\27\0\1\124\14\0"+
    "\1\124\7\0\1\125\25\31\2\0\1\31\35\0\1\50"+
    "\10\31\1\126\14\31\2\0\1\31\10\0\1\127\14\0"+
    "\1\127\7\0\1\130\76\0\1\127\27\0\1\127\14\0"+
    "\1\127\6\0\1\110\27\0\1\131\36\0\1\50\12\31"+
    "\1\132\12\31\2\0\1\31\12\0\1\133\14\0\1\133"+
    "\20\0\1\133\27\0\1\133\14\0\1\133\5\0\1\50"+
    "\23\31\1\134\1\31\2\0\1\31\23\0\1\135\11\0"+
    "\1\50\4\31\1\136\20\31\2\0\1\31\4\0\1\137"+
    "\54\0\1\135\27\0\1\135\16\0\1\137\27\0\1\137"+
    "\30\0\1\50\24\31\1\140\2\0\1\31\24\0\1\141"+
    "\35\0\1\141\27\0\1\141\10\0\1\50\20\31\1\142"+
    "\4\31\2\0\1\31\20\0\1\143\35\0\1\143\27\0"+
    "\1\143\14\0\1\50\21\31\1\144\3\31\2\0\1\31"+
    "\21\0\1\145\4\0\1\145\30\0\1\145\27\0\1\145"+
    "\4\0\1\145\1\0\1\125\1\0\3\125\1\146\25\125"+
    "\2\0\31\125\5\0\1\50\16\31\1\147\6\31\2\0"+
    "\1\31\16\0\1\150\35\0\1\150\27\0\1\150\11\0"+
    "\1\130\1\0\3\130\1\151\25\130\2\0\31\130\5\0"+
    "\1\152\25\31\2\0\1\31\35\0\1\153\65\0\1\50"+
    "\22\31\1\154\2\31\2\0\1\31\22\0\1\155\35\0"+
    "\1\155\27\0\1\155\12\0\1\50\5\31\1\104\17\31"+
    "\2\0\1\31\5\0\1\106\35\0\1\106\27\0\1\106"+
    "\27\0\1\50\17\31\1\156\5\31\2\0\1\31\17\0"+
    "\1\157\35\0\1\157\27\0\1\157\15\0\1\50\4\31"+
    "\1\160\20\31\2\0\1\31\4\0\1\161\35\0\1\161"+
    "\27\0\1\161\30\0\1\50\22\31\1\162\2\31\2\0"+
    "\1\31\22\0\1\163\35\0\1\163\27\0\1\163\11\0"+
    "\1\164\66\0\1\50\15\31\1\165\7\31\2\0\1\31"+
    "\15\0\1\166\35\0\1\166\27\0\1\166\16\0\1\167"+
    "\61\0\1\50\1\0\3\50\1\170\25\50\2\0\31\50"+
    "\5\0\1\171\65\0\1\50\7\31\1\172\15\31\2\0"+
    "\1\31\7\0\1\173\35\0\1\173\27\0\1\173\25\0"+
    "\1\50\4\31\1\165\20\31\2\0\1\31\4\0\1\166"+
    "\35\0\1\166\27\0\1\166\30\0\1\50\5\31\1\174"+
    "\17\31\2\0\1\31\5\0\1\175\35\0\1\175\27\0"+
    "\1\175\27\0\1\50\20\31\1\176\4\31\2\0\1\31"+
    "\20\0\1\177\35\0\1\177\27\0\1\177\13\0\1\164"+
    "\27\0\1\200\36\0\1\201\25\31\2\0\1\31\35\0"+
    "\1\202\64\0\1\167\27\0\1\203\35\0\1\204\65\0"+
    "\1\205\66\0\1\206\25\31\2\0\1\31\35\0\1\207"+
    "\65\0\1\125\25\31\2\0\1\210\35\0\1\130\27\0"+
    "\1\211\35\0\1\50\24\31\1\165\2\0\1\31\24\0"+
    "\1\166\35\0\1\166\27\0\1\166\3\0\33\212\1\0"+
    "\32\212\1\201\1\0\3\201\1\213\25\201\2\0\31\201"+
    "\1\202\1\0\3\202\1\214\25\202\2\0\31\202\4\0"+
    "\1\204\27\0\1\215\35\0\1\205\27\0\1\216\31\0"+
    "\1\206\1\0\3\206\1\217\25\206\2\0\31\206\1\207"+
    "\1\0\3\207\1\220\25\207\2\0\31\207\5\0\1\50"+
    "\17\31\1\221\5\31\2\0\1\31\17\0\1\222\35\0"+
    "\1\222\27\0\1\222\10\0\33\212\1\223\32\212\4\0"+
    "\1\224\65\0\1\225\114\0\1\226\36\0\1\227\65\0"+
    "\1\230\66\0\1\50\1\231\24\31\2\0\1\31\1\232"+
    "\35\0\1\232\27\0\1\232\32\0\1\233\66\0\1\224"+
    "\27\0\1\234\35\0\1\225\27\0\1\235\34\0\1\236"+
    "\66\0\1\227\27\0\1\237\35\0\1\230\27\0\1\240"+
    "\36\0\1\50\20\31\1\241\4\31\2\0\1\31\20\0"+
    "\1\242\35\0\1\242\27\0\1\242\30\0\1\243\27\0"+
    "\1\243\14\0\33\244\1\0\32\244\21\0\1\245\27\0"+
    "\1\245\14\0\33\246\1\0\32\246\5\0\1\50\22\31"+
    "\1\104\2\31\2\0\1\31\22\0\1\106\35\0\1\106"+
    "\27\0\1\106\25\0\1\247\27\0\1\247\14\0\1\247"+
    "\33\244\1\226\32\244\20\0\1\250\27\0\1\250\14\0"+
    "\1\250\33\246\1\251\32\246\23\0\1\252\27\0\1\252"+
    "\35\0\1\253\27\0\1\253\15\0\1\254\116\0\1\255"+
    "\65\0\1\4\52\0\1\256\27\0\1\256\34\0\1\257"+
    "\27\0\1\257\14\0\1\257\23\0\1\260\27\0\1\260"+
    "\46\0\1\261\31\0";

  private static int [] zzUnpacktrans() {
    int [] result = new int[8910];
    int offset = 0;
    offset = zzUnpacktrans(ZZ_TRANS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpacktrans(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      value--;
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /** Error code for "Unknown internal scanner error". */
  private static final int ZZ_UNKNOWN_ERROR = 0;
  /** Error code for "could not match input". */
  private static final int ZZ_NO_MATCH = 1;
  /** Error code for "pushback value was too large". */
  private static final int ZZ_PUSHBACK_2BIG = 2;

  /**
   * Error messages for {@link #ZZ_UNKNOWN_ERROR}, {@link #ZZ_NO_MATCH}, and
   * {@link #ZZ_PUSHBACK_2BIG} respectively.
   */
  private static final String ZZ_ERROR_MSG[] = {
    "Unknown internal scanner error",
    "Error: could not match input",
    "Error: pushback value was too large"
  };

  /**
   * ZZ_ATTRIBUTE[aState] contains the attributes of state {@code aState}
   */
  private static final int [] ZZ_ATTRIBUTE = zzUnpackAttribute();

  private static final String ZZ_ATTRIBUTE_PACKED_0 =
    "\2\0\2\11\7\1\4\0\1\1\3\0\1\11\3\0"+
    "\1\11\100\0\1\11\46\0\1\1\14\0\1\1\16\0"+
    "\1\1\2\0\1\1\15\0\1\11\3\0\1\11";

  private static int [] zzUnpackAttribute() {
    int [] result = new int[177];
    int offset = 0;
    offset = zzUnpackAttribute(ZZ_ATTRIBUTE_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAttribute(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /** Input device. */
  private java.io.Reader zzReader;

  /** Current state of the DFA. */
  private int zzState;

  /** Current lexical state. */
  private int zzLexicalState = YYINITIAL;

  /**
   * This buffer contains the current text to be matched and is the source of the {@link #yytext()}
   * string.
   */
  private char zzBuffer[] = new char[Math.min(ZZ_BUFFERSIZE, zzMaxBufferLen())];

  /** Text position at the last accepting state. */
  private int zzMarkedPos;

  /** Current text position in the buffer. */
  private int zzCurrentPos;

  /** Marks the beginning of the {@link #yytext()} string in the buffer. */
  private int zzStartRead;

  /** Marks the last character in the buffer, that has been read from input. */
  private int zzEndRead;

  /**
   * Whether the scanner is at the end of file.
   * @see #yyatEOF
   */
  private boolean zzAtEOF;

  /**
   * The number of occupied positions in {@link #zzBuffer} beyond {@link #zzEndRead}.
   *
   * <p>When a lead/high surrogate has been read from the input stream into the final
   * {@link #zzBuffer} position, this will have a value of 1; otherwise, it will have a value of 0.
   */
  private int zzFinalHighSurrogate = 0;

  /** Number of newlines encountered up to the start of the matched text. */
  private int yyline;

  /** Number of characters from the last newline up to the start of the matched text. */
  private int yycolumn;

  /** Number of characters up to the start of the matched text. */
  private long yychar;

  /** Whether the scanner is currently at the beginning of a line. */
  @SuppressWarnings("unused")
  private boolean zzAtBOL = true;

  /** Whether the user-EOF-code has already been executed. */
  @SuppressWarnings("unused")
  private boolean zzEOFDone;

  /* user code: */
	
	S202_NearAuthorities() { }
	
	private AnnotationEntity lastAuthority = null;
	
	ReferenceClusters referenceClusters = null;
	
	


  /**
   * Creates a new scanner
   *
   * @param   in  the java.io.Reader to read input from.
   */
  S202_NearAuthorities(java.io.Reader in) {
    this.zzReader = in;
  }


  /** Returns the maximum size of the scanner buffer, which limits the size of tokens. */
  private int zzMaxBufferLen() {
    return Integer.MAX_VALUE;
  }

  /**  Whether the scanner buffer can grow to accommodate a larger token. */
  private boolean zzCanGrow() {
    return true;
  }

  /**
   * Translates raw input code points to DFA table row
   */
  private static int zzCMap(int input) {
    int offset = input & 255;
    return offset == input ? ZZ_CMAP_BLOCKS[offset] : ZZ_CMAP_BLOCKS[ZZ_CMAP_TOP[input >> 8] | offset];
  }

  /**
   * Refills the input buffer.
   *
   * @return {@code false} iff there was new input.
   * @exception java.io.IOException  if any I/O-Error occurs
   */
  private boolean zzRefill() throws java.io.IOException {

    /* first: make room (if you can) */
    if (zzStartRead > 0) {
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
      System.arraycopy(zzBuffer, zzStartRead,
                       zzBuffer, 0,
                       zzEndRead - zzStartRead);

      /* translate stored positions */
      zzEndRead -= zzStartRead;
      zzCurrentPos -= zzStartRead;
      zzMarkedPos -= zzStartRead;
      zzStartRead = 0;
    }

    /* is the buffer big enough? */
    if (zzCurrentPos >= zzBuffer.length - zzFinalHighSurrogate && zzCanGrow()) {
      /* if not, and it can grow: blow it up */
      char newBuffer[] = new char[Math.min(zzBuffer.length * 2, zzMaxBufferLen())];
      System.arraycopy(zzBuffer, 0, newBuffer, 0, zzBuffer.length);
      zzBuffer = newBuffer;
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
    }

    /* fill the buffer with new input */
    int requested = zzBuffer.length - zzEndRead;
    int numRead = zzReader.read(zzBuffer, zzEndRead, requested);

    /* not supposed to occur according to specification of java.io.Reader */
    if (numRead == 0) {
      if (requested == 0) {
        throw new java.io.EOFException("Scan buffer limit reached ["+zzBuffer.length+"]");
      }
      else {
        throw new java.io.IOException(
            "Reader returned 0 characters. See JFlex examples/zero-reader for a workaround.");
      }
    }
    if (numRead > 0) {
      zzEndRead += numRead;
      if (Character.isHighSurrogate(zzBuffer[zzEndRead - 1])) {
        if (numRead == requested) { // We requested too few chars to encode a full Unicode character
          --zzEndRead;
          zzFinalHighSurrogate = 1;
        } else {                    // There is room in the buffer for at least one more char
          int c = zzReader.read();  // Expecting to read a paired low surrogate char
          if (c == -1) {
            return true;
          } else {
            zzBuffer[zzEndRead++] = (char)c;
          }
        }
      }
      /* potentially more input available */
      return false;
    }

    /* numRead < 0 ==> end of stream */
    return true;
  }


  /**
   * Closes the input reader.
   *
   * @throws java.io.IOException if the reader could not be closed.
   */
  public final void yyclose() throws java.io.IOException {
    zzAtEOF = true; // indicate end of file
    zzEndRead = zzStartRead; // invalidate buffer

    if (zzReader != null) {
      zzReader.close();
    }
  }


  /**
   * Resets the scanner to read from a new input stream.
   *
   * <p>Does not close the old reader.
   *
   * <p>All internal variables are reset, the old input stream <b>cannot</b> be reused (internal
   * buffer is discarded and lost). Lexical state is set to {@code ZZ_INITIAL}.
   *
   * <p>Internal scan buffer is resized down to its initial length, if it has grown.
   *
   * @param reader The new input stream.
   */
  public final void yyreset(java.io.Reader reader) {
    zzReader = reader;
    zzEOFDone = false;
    yyResetPosition();
    zzLexicalState = YYINITIAL;
    int initBufferSize = Math.min(ZZ_BUFFERSIZE, zzMaxBufferLen());
    if (zzBuffer.length > initBufferSize) {
      zzBuffer = new char[initBufferSize];
    }
  }

  /**
   * Resets the input position.
   */
  private final void yyResetPosition() {
      zzAtBOL  = true;
      zzAtEOF  = false;
      zzCurrentPos = 0;
      zzMarkedPos = 0;
      zzStartRead = 0;
      zzEndRead = 0;
      zzFinalHighSurrogate = 0;
      yyline = 0;
      yycolumn = 0;
      yychar = 0L;
  }


  /**
   * Returns whether the scanner has reached the end of the reader it reads from.
   *
   * @return whether the scanner has reached EOF.
   */
  public final boolean yyatEOF() {
    return zzAtEOF;
  }


  /**
   * Returns the current lexical state.
   *
   * @return the current lexical state.
   */
  public final int yystate() {
    return zzLexicalState;
  }


  /**
   * Enters a new lexical state.
   *
   * @param newState the new lexical state
   */
  public final void yybegin(int newState) {
    zzLexicalState = newState;
  }


  /**
   * Returns the text matched by the current regular expression.
   *
   * @return the matched text.
   */
  public final String yytext() {
    return new String(zzBuffer, zzStartRead, zzMarkedPos-zzStartRead);
  }


  /**
   * Returns the character at the given position from the matched text.
   *
   * <p>It is equivalent to {@code yytext().charAt(pos)}, but faster.
   *
   * @param position the position of the character to fetch. A value from 0 to {@code yylength()-1}.
   *
   * @return the character at {@code position}.
   */
  public final char yycharat(int position) {
    return zzBuffer[zzStartRead + position];
  }


  /**
   * How many characters were matched.
   *
   * @return the length of the matched text region.
   */
  public final int yylength() {
    return zzMarkedPos-zzStartRead;
  }


  /**
   * Reports an error that occurred while scanning.
   *
   * <p>In a well-formed scanner (no or only correct usage of {@code yypushback(int)} and a
   * match-all fallback rule) this method will only be called with things that
   * "Can't Possibly Happen".
   *
   * <p>If this method is called, something is seriously wrong (e.g. a JFlex bug producing a faulty
   * scanner etc.).
   *
   * <p>Usual syntax/scanner level error handling should be done in error fallback rules.
   *
   * @param errorCode the code of the error message to display.
   */
  private static void zzScanError(int errorCode) {
    String message;
    try {
      message = ZZ_ERROR_MSG[errorCode];
    } catch (ArrayIndexOutOfBoundsException e) {
      message = ZZ_ERROR_MSG[ZZ_UNKNOWN_ERROR];
    }

    throw new Error(message);
  }


  /**
   * Pushes the specified amount of characters back into the input stream.
   *
   * <p>They will be read again by then next call of the scanning method.
   *
   * @param number the number of characters to be read again. This number must not be greater than
   *     {@link #yylength()}.
   */
  public void yypushback(int number)  {
    if ( number > yylength() )
      zzScanError(ZZ_PUSHBACK_2BIG);

    zzMarkedPos -= number;
  }




  /**
   * Resumes scanning until the next regular expression is matched, the end of input is encountered
   * or an I/O-Error occurs.
   *
   * @return the next token.
   * @exception java.io.IOException if any I/O-Error occurs.
   */
  public int yylex() throws java.io.IOException
  {
    int zzInput;
    int zzAction;

    // cached fields:
    int zzCurrentPosL;
    int zzMarkedPosL;
    int zzEndReadL = zzEndRead;
    char[] zzBufferL = zzBuffer;

    int [] zzTransL = ZZ_TRANS;
    int [] zzRowMapL = ZZ_ROWMAP;
    int [] zzAttrL = ZZ_ATTRIBUTE;

    while (true) {
      zzMarkedPosL = zzMarkedPos;

      yychar+= zzMarkedPosL-zzStartRead;

      boolean zzR = false;
      int zzCh;
      int zzCharCount;
      for (zzCurrentPosL = zzStartRead  ;
           zzCurrentPosL < zzMarkedPosL ;
           zzCurrentPosL += zzCharCount ) {
        zzCh = Character.codePointAt(zzBufferL, zzCurrentPosL, zzMarkedPosL);
        zzCharCount = Character.charCount(zzCh);
        switch (zzCh) {
        case '\u000B':  // fall through
        case '\u000C':  // fall through
        case '\u0085':  // fall through
        case '\u2028':  // fall through
        case '\u2029':
          yyline++;
          yycolumn = 0;
          zzR = false;
          break;
        case '\r':
          yyline++;
          yycolumn = 0;
          zzR = true;
          break;
        case '\n':
          if (zzR)
            zzR = false;
          else {
            yyline++;
            yycolumn = 0;
          }
          break;
        default:
          zzR = false;
          yycolumn += zzCharCount;
        }
      }

      if (zzR) {
        // peek one character ahead if it is
        // (if we have counted one line too much)
        boolean zzPeek;
        if (zzMarkedPosL < zzEndReadL)
          zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        else if (zzAtEOF)
          zzPeek = false;
        else {
          boolean eof = zzRefill();
          zzEndReadL = zzEndRead;
          zzMarkedPosL = zzMarkedPos;
          zzBufferL = zzBuffer;
          if (eof)
            zzPeek = false;
          else
            zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        }
        if (zzPeek) yyline--;
      }
      zzAction = -1;

      zzCurrentPosL = zzCurrentPos = zzStartRead = zzMarkedPosL;

      zzState = ZZ_LEXSTATE[zzLexicalState];

      // set up zzAction for empty match case:
      int zzAttributes = zzAttrL[zzState];
      if ( (zzAttributes & 1) == 1 ) {
        zzAction = zzState;
      }


      zzForAction: {
        while (true) {

          if (zzCurrentPosL < zzEndReadL) {
            zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
            zzCurrentPosL += Character.charCount(zzInput);
          }
          else if (zzAtEOF) {
            zzInput = YYEOF;
            break zzForAction;
          }
          else {
            // store back cached positions
            zzCurrentPos  = zzCurrentPosL;
            zzMarkedPos   = zzMarkedPosL;
            boolean eof = zzRefill();
            // get translated positions and possibly new buffer
            zzCurrentPosL  = zzCurrentPos;
            zzMarkedPosL   = zzMarkedPos;
            zzBufferL      = zzBuffer;
            zzEndReadL     = zzEndRead;
            if (eof) {
              zzInput = YYEOF;
              break zzForAction;
            }
            else {
              zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
              zzCurrentPosL += Character.charCount(zzInput);
            }
          }
          int zzNext = zzTransL[ zzRowMapL[zzState] + zzCMap(zzInput) ];
          if (zzNext == -1) break zzForAction;
          zzState = zzNext;

          zzAttributes = zzAttrL[zzState];
          if ( (zzAttributes & 1) == 1 ) {
            zzAction = zzState;
            zzMarkedPosL = zzCurrentPosL;
            if ( (zzAttributes & 8) == 8 ) break zzForAction;
          }

        }
      }

      // store back cached position
      zzMarkedPos = zzMarkedPosL;

      if (zzInput == YYEOF && zzStartRead == zzCurrentPos) {
        zzAtEOF = true;
        return YYEOF;
      }
      else {
        switch (zzAction < 0 ? zzAction : ZZ_ACTION[zzAction]) {
          case 1:
            { position++;
            }
          // fall through
          case 8: break;
          case 2:
            { lastAuthority = null;
            }
          // fall through
          case 9: break;
          case 3:
            { 
            }
          // fall through
          case 10: break;
          case 4:
            { position--; //account for the following {LKN_C} character
		yybegin(YYINITIAL);
            }
          // fall through
          case 11: break;
          case 5:
            { yybegin(lkn);
            }
          // fall through
          case 12: break;
          case 6:
            { if(lastAuthority != null) {
	
		Reference ref = (Reference) retrieveEntity();

		if(referenceClusters.getAuthority(ref) == null && referenceClusters.getAuthSection(ref) == null && referenceClusters.getOtherAuthority(ref) == null && referenceClusters.getMinistry(ref) == null && 
			referenceClusters.getRegion(ref) == null && referenceClusters.getCity(ref) == null && referenceClusters.getDetachedSection(ref) == null &&
			referenceClusters.getDocumentType(ref) != null && (referenceClusters.getDocumentType(ref).getValue().equals("SENT") || referenceClusters.getDocumentType(ref).getValue().equals("ORD") ) && 
			referenceClusters.getPartition(ref) == null && referenceClusters.getEuAcronym(ref) == null && referenceClusters.getGuAttr(ref) == null 
			) {

			//if(getLinkolnDocument().isDebug())
				System.out.println("NearAuthorities: " + lastAuthority + " ==> " + ref);
			
			referenceClusters.addAuthority(ref, lastAuthority);
		
		} else {
			
			lastAuthority = null;
		}
	}
            }
          // fall through
          case 13: break;
          case 7:
            { AnnotationEntity retrievedEntity = retrieveEntity();
	
	lastAuthority = retrievedEntity;
            }
          // fall through
          case 14: break;
          default:
            zzScanError(ZZ_NO_MATCH);
        }
      }
    }
  }

  /**
   * Runs the scanner on input files.
   *
   * This is a standalone scanner, it will print any unmatched
   * text to System.out unchanged.
   *
   * @param argv   the command line, contains the filenames to run
   *               the scanner on.
   */
  public static void main(String[] argv) {
    if (argv.length == 0) {
      System.out.println("Usage : java S202_NearAuthorities [ --encoding <name> ] <inputfile(s)>");
    }
    else {
      int firstFilePos = 0;
      String encodingName = "UTF-8";
      if (argv[0].equals("--encoding")) {
        firstFilePos = 2;
        encodingName = argv[1];
        try {
          // Side-effect: is encodingName valid?
          java.nio.charset.Charset.forName(encodingName);
        } catch (Exception e) {
          System.out.println("Invalid encoding '" + encodingName + "'");
          return;
        }
      }
      for (int i = firstFilePos; i < argv.length; i++) {
        S202_NearAuthorities scanner = null;
        java.io.FileInputStream stream = null;
        java.io.Reader reader = null;
        try {
          stream = new java.io.FileInputStream(argv[i]);
          reader = new java.io.InputStreamReader(stream, encodingName);
          scanner = new S202_NearAuthorities(reader);
          while ( !scanner.zzAtEOF ) scanner.yylex();
        }
        catch (java.io.FileNotFoundException e) {
          System.out.println("File not found : \""+argv[i]+"\"");
        }
        catch (java.io.IOException e) {
          System.out.println("IO error scanning file \""+argv[i]+"\"");
          System.out.println(e);
        }
        catch (Exception e) {
          System.out.println("Unexpected exception:");
          e.printStackTrace();
        }
        finally {
          if (reader != null) {
            try {
              reader.close();
            }
            catch (java.io.IOException e) {
              System.out.println("IO error closing file \""+argv[i]+"\"");
              System.out.println(e);
            }
          }
          if (stream != null) {
            try {
              stream.close();
            }
            catch (java.io.IOException e) {
              System.out.println("IO error closing file \""+argv[i]+"\"");
              System.out.println(e);
            }
          }
        }
      }
    }
  }


}
